#![feature(box_as_ptr, let_chains)]

use rand::random;

use hercules_rt::HerculesBox;

juno_build::juno!("code");

fn main() {
    async_std::task::block_on(async {
        const N: usize = 256;
        const M: usize = 64;
        const K: usize = 128;
        let a: Box<[i32]> = (0..N * M).map(|_| random::<i32>() % 100).collect();
        let b: Box<[i32]> = (0..M * K).map(|_| random::<i32>() % 100).collect();
        let c: Box<[i32]> = (0..K).map(|_| random::<i32>() % 100).collect();

        let mut correct_res: Box<[i32]> = (0..N).map(|_| 0).collect();
        for i in 0..N {
            for j in 0..K {
                let mut res = 0;
                for k in 0..M {
                    res += a[i * M + k] * b[k * K + j];
                }
                correct_res[i] += c[j] * res;
            }
        }

        let mut res = {
            let a = HerculesBox::from_slice(&a);
            let b = HerculesBox::from_slice(&b);
            let c = HerculesBox::from_slice(&c);
            test(N as u64, M as u64, K as u64, a, b, c).await
        };
        assert_eq!(res.as_slice::<i32>(), &*correct_res);
    });
}

#[test]
fn schedule_test() {
    main();
}
